Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/HeuristicLab.Problems.Instances.PermutationProblems-3.3.csproj
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/HeuristicLab.Problems.Instances.PermutationProblems-3.3.csproj	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/HeuristicLab.Problems.Instances.PermutationProblems-3.3.csproj	(revision 15686)
@@ -18,5 +18,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -26,5 +26,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/Plugin.cs
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/Plugin.cs	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/Plugin.cs	(revision 15686)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Instances.LinearOrdering {
-  [Plugin("HeuristicLab.Problems.Instances.PermutationProblems", "3.3.15.15661")]
+  [Plugin("HeuristicLab.Problems.Instances.PermutationProblems", "3.3.15.15662")]
   [PluginFile("HeuristicLab.Problems.Instances.PermutationProblems-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/Properties/AssemblyInfo.cs	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.PermutationProblems/3.3/Properties/AssemblyInfo.cs	(revision 15686)
@@ -55,3 +55,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.14.15661")]
+[assembly: AssemblyFileVersion("3.3.14.15662")]
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj	(revision 15686)
@@ -19,5 +19,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -28,5 +28,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Plugin.cs
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Plugin.cs	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Plugin.cs	(revision 15686)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Instances {
-  [Plugin("HeuristicLab.Problems.Instances", "3.3.15.15661")]
+  [Plugin("HeuristicLab.Problems.Instances", "3.3.15.15662")]
   [PluginFile("HeuristicLab.Problems.Instances-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Properties/AssemblyInfo.cs	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Properties/AssemblyInfo.cs	(revision 15686)
@@ -55,3 +55,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.14.15661")]
+[assembly: AssemblyFileVersion("3.3.14.15662")]
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/HeuristicLab.Problems.PermutationProblems.Views-3.3.csproj
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/HeuristicLab.Problems.PermutationProblems.Views-3.3.csproj	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/HeuristicLab.Problems.PermutationProblems.Views-3.3.csproj	(revision 15686)
@@ -19,5 +19,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -28,5 +28,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/Plugin.cs
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/Plugin.cs	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/Plugin.cs	(revision 15686)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.PermutationProblems.Views {
-  [Plugin("HeuristicLab.Problems.PermutationProblems.Views", "3.3.15.15661")]
+  [Plugin("HeuristicLab.Problems.PermutationProblems.Views", "3.3.15.15662")]
   [PluginFile("HeuristicLab.Problems.PermutationProblems.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/Properties/AssemblyInfo.cs	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems.Views/3.3/Properties/AssemblyInfo.cs	(revision 15686)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.14.15661")]
+[assembly: AssemblyFileVersion("3.3.14.15662")]
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/HeuristicLab.Problems.PermutationProblems-3.3.csproj
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/HeuristicLab.Problems.PermutationProblems-3.3.csproj	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/HeuristicLab.Problems.PermutationProblems-3.3.csproj	(revision 15686)
@@ -18,5 +18,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -26,5 +26,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/Plugin.cs
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/Plugin.cs	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/Plugin.cs	(revision 15686)
@@ -24,5 +24,5 @@
 namespace HeuristicLab.Problems.PermutationProblems
 {
-  [Plugin("HeuristicLab.Problems.PermutationProblems", "3.3.15.15661")]
+  [Plugin("HeuristicLab.Problems.PermutationProblems", "3.3.15.15662")]
   [PluginFile("HeuristicLab.Problems.PermutationProblems-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/Properties/AssemblyInfo.cs	(revision 15685)
+++ /branches/2864_PermutationProblems/HeuristicLab.Problems.PermutationProblems/3.3/Properties/AssemblyInfo.cs	(revision 15686)
@@ -54,4 +54,4 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.14.15661")]
+[assembly: AssemblyFileVersion("3.3.14.15662")]
 